Index: Jenkins/FullBuild
===================================================================
--- Jenkins/FullBuild	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ Jenkins/FullBuild	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -32,5 +32,5 @@
 
 			stage('Package') {
-				trigger_dist( commitId, currentBuild.number.toString() )
+				build job: 'Cforall_Distribute_Ref', parameters: [string(name: 'GitRef', value: commitId), string(name: 'Build', value: currentBuild.number.toString())]
 			}
 		}
@@ -103,20 +103,4 @@
 }
 
-def trigger_dist(String commitId, String buildNum) {
-	def result = build job: 'Cforall_Distribute_Ref',	\
-		parameters: [						\
-			string(name: 'GitRef', value: commitId),	\
-			string(name: 'Build' , value: buildNum)	\
-		],								\
-		propagate: false
-
-	echo(result.result)
-
-	if(result.result != 'SUCCESS') {
-		sh("wget -q -O - https://cforall.uwaterloo.ca/jenkins/job/Cforall_Distribute_Ref/${result.number}/consoleText")
-		error(result.result)
-	}
-}
-
 //===========================================================================================================
 //Routine responsible of sending the email notification once the build is completed
Index: Jenkins/tools.groovy
===================================================================
--- Jenkins/tools.groovy	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ Jenkins/tools.groovy	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -6,8 +6,12 @@
 import org.jenkinsci.plugins.pipeline.modeldefinition.Utils
 
+// Global for the stage name
+StageName = ''
+
 // wrapper around stage declaretion to be more verbose
 // and allow showing as skipped in the UI
 def BuildStage(String name, boolean run, Closure block ) {
-	echo " -------- ${name} -------- "
+	StageName = name
+	echo " -------- ${StageName} -------- "
 	if(run) {
 		stage(name, block)
Index: Jenkinsfile
===================================================================
--- Jenkinsfile	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ Jenkinsfile	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -54,15 +54,14 @@
 	//attach the build log to the email
 	catch (Exception caughtError) {
-		// Store the result of the build log
-		currentBuild.result = "FAILURE"
-
-		// An error has occured, the build log is relevent
+		//rethrow error later
+		err = caughtError
+
+		echo err.toString()
+
+		//An error has occured, the build log is relevent
 		log_needed = true
 
-		// rethrow error later
-		err = caughtError
-
-		// print the error so it shows in the log
-		echo err.toString()
+		//Store the result of the build log
+		currentBuild.result = "${tools.StageName} FAILURE".trim()
 	}
 
Index: benchmark/Makefile.am
===================================================================
--- benchmark/Makefile.am	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/Makefile.am	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -522,8 +522,2 @@
 size-cfa$(EXEEXT):
 	$(BENCH_V_CFA)$(CFACOMPILE) $(srcdir)/size/size.cfa
-
-## =========================================================================================================
-
-%-tokio$(EXEEXT): $(srcdir)/readyQ/%.rs $(srcdir)/bench.rs
-	cd $(builddir) && cargo build --release
-	cp $(builddir)/target/release/$(basename $@) $@
Index: benchmark/creation/node_cor.js
===================================================================
--- benchmark/creation/node_cor.js	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/creation/node_cor.js	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -6,5 +6,5 @@
 function * coroutine() { yield }
 
-for ( var i = 0; i < times; i += 1 ) { // warm JIT
+for ( var i = 0; i < times; i += 1 ) { // warm jit
 	cor = coroutine()
 }
Index: benchmark/ctxswitch/node_cor.js
===================================================================
--- benchmark/ctxswitch/node_cor.js	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/ctxswitch/node_cor.js	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -11,5 +11,5 @@
 cor = coroutine()
 
-for ( var i = 0; i < times; i += 1 ) { // warm JIT
+for ( var i = 0; i < times; i += 1 ) { // warm git
 	cor.next();
 }
Index: benchmark/readyQ/bench.go
===================================================================
--- benchmark/readyQ/bench.go	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/readyQ/bench.go	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -5,8 +5,6 @@
 	"flag"
 	"fmt"
-	"log"
 	"os"
 	"runtime"
-	"runtime/pprof"
 	"sync/atomic"
 	"time"
@@ -45,10 +43,9 @@
 }
 
-func bench_init() func() {
+func bench_init() {
 	nprocsOpt := flag.Int("p", 1, "The number of processors")
 	nthreadsOpt := flag.Int("t", 1, "The number of threads")
 	durationOpt := flag.Float64("d", 0, "Duration of the experiment in seconds")
 	stopOpt := flag.Uint64("i", 0, "Duration of the experiment in iterations")
-	cpuprofile := flag.String("cpuprofile", "", "write cpu profile to file")
 
 	flag.Parse()
@@ -75,17 +72,3 @@
 
 	runtime.GOMAXPROCS(nprocs)
-
-	if (*cpuprofile) != "" {
-		f, err := os.Create(*cpuprofile)
-		if err != nil {
-		    log.Fatal(err)
-		}
-		pprof.StartCPUProfile(f)
-	}
-
-	return func() {
-		if (*cpuprofile) != "" {
-			pprof.StopCPUProfile()
-		}
-	}
 }
Index: benchmark/readyQ/cycle.cpp
===================================================================
--- benchmark/readyQ/cycle.cpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/readyQ/cycle.cpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -71,5 +71,5 @@
 		{ 'r', "ringsize", "Number of threads in a cycle", ring_size }
 	};
-	BENCH_OPT_PARSE("libfibre cycle benchmark");
+	BENCH_OPT_PARSE("cforall cycle benchmark");
 
 	{
Index: benchmark/readyQ/cycle.rs
===================================================================
--- benchmark/readyQ/cycle.rs	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/readyQ/cycle.rs	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -1,16 +1,67 @@
+#[cfg(any(
+	feature = "sync time rt-threaded",
+  ))]
+
+extern crate tokio;
+
+use std::io::{self, Write};
 use std::sync::Arc;
-use std::sync::atomic::Ordering;
-use std::time::Instant;
+use std::sync::atomic::{AtomicU64, AtomicBool,Ordering};
+use std::time::{Instant,Duration};
 
 use tokio::runtime::Builder;
 use tokio::sync;
-
+use tokio::time;
+
+extern crate isatty;
+use isatty::stdout_isatty;
+
+extern crate num_format;
+use num_format::{Locale, ToFormattedString};
+
+extern crate clap;
 use clap::{Arg, App};
-use num_format::{Locale, ToFormattedString};
-
-#[path = "../bench.rs"]
-mod bench;
-
-// ==================================================
+
+use std::cell::UnsafeCell;
+use std::mem::MaybeUninit;
+use std::ops;
+
+pub struct InitializeCell<T> {
+    inner: UnsafeCell<MaybeUninit<T>>,
+}
+
+unsafe impl<T> Sync for InitializeCell<T> {}
+
+impl<T> InitializeCell<T> {
+    pub const unsafe fn new_uninitialized() -> InitializeCell<T> {
+	  InitializeCell {
+		inner: UnsafeCell::new(MaybeUninit::uninit()),
+	  }
+    }
+    pub const fn new(init: T) -> InitializeCell<T> {
+	  InitializeCell {
+		inner: UnsafeCell::new(MaybeUninit::new(init)),
+	  }
+    }
+    pub unsafe fn init(&self, init: T) {
+	  (*self.inner.get()) = MaybeUninit::new(init);
+    }
+}
+
+impl<T> ops::Deref for InitializeCell<T> {
+    type Target = T;
+    fn deref(&self) -> &T {
+	  unsafe {
+		&*(*self.inner.get()).as_ptr()
+	  }
+    }
+}
+
+static CLOCK_MODE: InitializeCell<bool> = unsafe { InitializeCell::new_uninitialized() };
+static STOP_COUNT: InitializeCell<u64>  = unsafe { InitializeCell::new_uninitialized() };
+static DURATION: InitializeCell<f64>    = unsafe { InitializeCell::new_uninitialized() };
+static STOP         : AtomicBool = AtomicBool::new(false);
+static THREADS_LEFT : AtomicU64  = AtomicU64 ::new(10);
+
 struct Partner {
 	sem: sync::Semaphore,
@@ -18,5 +69,5 @@
 }
 
-async fn partner_main(idx: usize, others: Arc<Vec<Arc<Partner>>>, exp: Arc<bench::BenchData> ) -> u64 {
+async fn partner_main(result: sync::oneshot::Sender<u64>, idx: usize, others: Arc<Vec<Arc<Partner>>> ) {
 	let this = &others[idx];
 	let mut count:u64 = 0;
@@ -26,16 +77,47 @@
 		count += 1;
 
-		if  exp.clock_mode && exp.stop.load(Ordering::Relaxed) { break; }
-		if !exp.clock_mode && count >= exp.stop_count { break; }
-	}
-
-	exp.threads_left.fetch_sub(1, Ordering::SeqCst);
-	count
-}
-
-// ==================================================
+		if  *CLOCK_MODE && STOP.load(Ordering::Relaxed) { break; }
+		if !*CLOCK_MODE && count >= *STOP_COUNT { break; }
+	}
+
+	THREADS_LEFT.fetch_sub(1, Ordering::SeqCst);
+	result.send( count ).unwrap();
+}
+
+fn prep(nthreads: usize, tthreads: usize) -> Vec<Arc<Partner>> {
+	let mut thddata = Vec::with_capacity(tthreads);
+	for i in 0..tthreads {
+		let pi = (i + nthreads) % tthreads;
+		thddata.push(Arc::new(Partner{
+			sem: sync::Semaphore::new(0),
+			next: pi,
+		}));
+	}
+	return thddata;
+}
+
+async fn wait(start: &Instant, is_tty: bool) {
+	loop {
+		time::sleep(Duration::from_micros(100000)).await;
+		let delta = start.elapsed();
+		if is_tty {
+			print!(" {:.1}\r", delta.as_secs_f32());
+			io::stdout().flush().unwrap();
+		}
+		if *CLOCK_MODE && delta >= Duration::from_secs_f64(*DURATION)  {
+			break;
+		}
+		else if !*CLOCK_MODE && THREADS_LEFT.load(Ordering::Relaxed) == 0 {
+			break;
+		}
+	}
+}
+
 fn main() {
 	let options = App::new("Cycle Tokio")
-		.args(&bench::args())
+		.arg(Arg::with_name("duration")  .short("d").long("duration")  .takes_value(true).default_value("5").help("Duration of the experiments in seconds"))
+		.arg(Arg::with_name("iterations").short("i").long("iterations").takes_value(true).conflicts_with("duration").help("Number of iterations of the experiments"))
+		.arg(Arg::with_name("nthreads")  .short("t").long("nthreads")  .takes_value(true).default_value("1").help("Number of threads to use"))
+		.arg(Arg::with_name("nprocs")    .short("p").long("nprocs")    .takes_value(true).default_value("1").help("Number of processors to use"))
 		.arg(Arg::with_name("ringsize")  .short("r").long("ringsize")  .takes_value(true).default_value("1").help("Number of threads in a cycle"))
 		.get_matches();
@@ -45,19 +127,24 @@
 	let nprocs    = options.value_of("nprocs").unwrap().parse::<usize>().unwrap();
 
-	let tthreads = nthreads * ring_size;
-	let exp = Arc::new(bench::BenchData::new(options, tthreads));
+	if options.is_present("iterations") {
+		unsafe{
+			CLOCK_MODE.init( false );
+			STOP_COUNT.init( options.value_of("iterations").unwrap().parse::<u64>().unwrap() );
+		}
+	}
+	else {
+		unsafe{
+			CLOCK_MODE.init(true);
+			DURATION  .init(options.value_of("duration").unwrap().parse::<f64>().unwrap());
+		}
+	}
 
 	let s = (1000000 as u64).to_formatted_string(&Locale::en);
 	assert_eq!(&s, "1,000,000");
 
-	let thddata : Arc<Vec<Arc<Partner>>> = Arc::new(
-		(0..tthreads).map(|i| {
-			let pi = (i + nthreads) % tthreads;
-			Arc::new(Partner{
-				sem: sync::Semaphore::new(0),
-				next: pi,
-			})
-		}).collect()
-	);
+
+	let tthreads = nthreads * ring_size;
+	THREADS_LEFT.store(tthreads as u64, Ordering::SeqCst);
+	let thddata = Arc::new(prep(nthreads, tthreads));
 
 	let mut global_counter :u64 = 0;
@@ -70,25 +157,35 @@
 
 	runtime.block_on(async {
-		let threads: Vec<_> = (0..tthreads).map(|i| {
-			tokio::spawn(partner_main(i, thddata.clone(), exp.clone()))
-		}).collect();
-		println!("Starting");
-
-		let start = Instant::now();
-
-		for i in 0..nthreads {
-			thddata[i].sem.add_permits(1);
-		}
-
-		duration = exp.wait(&start).await;
-
-		println!("\nDone");
-
-		for i in 0..tthreads {
-			thddata[i].sem.add_permits(1);
-		}
-
-		for t in threads {
-			global_counter += t.await.unwrap();
+		let mut result  : Vec<sync::oneshot::Receiver::<u64>> = Vec::with_capacity(tthreads);
+		{
+			let mut threads = Vec::with_capacity(tthreads);
+			for i in 0..tthreads {
+				let (s, r) = sync::oneshot::channel::<u64>();
+				result.push(r);
+				threads.push(tokio::spawn(partner_main(s, i, thddata.clone())));
+			}
+			println!("Starting");
+
+			let is_tty = stdout_isatty();
+			let start = Instant::now();
+
+			for i in 0..nthreads {
+				thddata[i].sem.add_permits(1);
+			}
+
+			wait(&start, is_tty).await;
+
+			STOP.store(true, Ordering::SeqCst);
+			duration = start.elapsed();
+
+			println!("\nDone");
+
+			for i in 0..tthreads {
+				thddata[i].sem.add_permits(1);
+			}
+
+			for _ in 0..tthreads {
+				global_counter += result.pop().unwrap().await.unwrap();
+			}
 		}
 	});
Index: benchmark/readyQ/locality.go
===================================================================
--- benchmark/readyQ/locality.go	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/readyQ/locality.go	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -2,28 +2,40 @@
 
 import (
-	"context"
 	"flag"
 	"fmt"
 	"math/rand"
 	"os"
-	"syscall"
 	"sync/atomic"
 	"time"
-	"unsafe"
-	"golang.org/x/sync/semaphore"
 	"golang.org/x/text/language"
 	"golang.org/x/text/message"
 )
 
-// ==================================================
-type MyData struct {
-	_p1 [16]uint64 // padding
-	ttid int
-	id int
-	data [] uint64
-	_p2 [16]uint64 // padding
+func handshake(stop chan struct {}, c chan [] uint64, data [] uint64, share bool) (bool, [] uint64) {
+	var s [] uint64 = data
+	if !share {
+		s = nil
+	}
+
+	// send the data
+	select {
+	case <- stop:
+		return true, nil
+	case c <- s:
+	}
+
+	// get the new data chunk
+	select {
+	case <- stop:
+		return true, nil
+	case n := <- c:
+		if share {
+			return false, n
+		}
+		return false, data
+	}
 }
 
-func NewData(id int, size uint64) (*MyData) {
+func local(result chan uint64, start chan struct{}, stop chan struct{}, size uint64, cnt uint64, channels []chan [] uint64, chan_cnt uint64, share bool) {
 	var data [] uint64
 	data = make([]uint64, size)
@@ -31,211 +43,36 @@
 		data[i] = 0
 	}
-	return &MyData{[16]uint64{0}, syscall.Gettid(), id, data,[16]uint64{0}}
+	count := uint64(0)
+	<- start
+	for true {
+		for i := uint64(0); i < cnt; i++ {
+			data[rand.Uint64() % size] += 1
+		}
+
+		i := rand.Uint64() % chan_cnt
+		var closed bool
+		closed, data = handshake(stop, channels[i], data, share)
+		count += 1
+
+		if  closed { break }
+		if !clock_mode && count >= stop_count { break }
+	}
+
+	atomic.AddInt64(&threads_left, -1);
+	result <- count
 }
 
-func (this * MyData) moved( ttid int ) (uint64) {
-	if this.ttid == ttid {
-		return 0
-	}
-	this.ttid = ttid
-	return 1
-}
+func main() {
 
-func (this * MyData) access( idx uint64 ) {
-	this.data[idx % uint64(len(this.data))] += 1
-}
-
-// ==================================================
-type MyCtx struct {
-	_p1 [16]uint64 // padding
-	s * semaphore.Weighted
-	d unsafe.Pointer
-	c context.Context
-	ttid int
-	id int
-	_p2 [16]uint64 // padding
-}
-
-func NewCtx( data * MyData, id int ) (MyCtx) {
-	r := MyCtx{[16]uint64{0},semaphore.NewWeighted(1), unsafe.Pointer(data), context.Background(), syscall.Gettid(), id,[16]uint64{0}}
-	r.s.Acquire(context.Background(), 1)
-	return r
-}
-
-func (this * MyCtx) moved( ttid int ) (uint64) {
-	if this.ttid == ttid {
-		return 0
-	}
-	this.ttid = ttid
-	return 1
-}
-
-// ==================================================
-// Atomic object where a single thread can wait
-// May exchanges data
-type Spot struct {
-	_p1 [16]uint64 // padding
-	ptr uintptr // atomic variable use fo MES
-	id int      // id for debugging
-	_p2 [16]uint64 // padding
-}
-
-// Main handshake of the code
-// Single seat, first thread arriving waits
-// Next threads unblocks current one and blocks in its place
-// if share == true, exchange data in the process
-func (this * Spot) put( ctx * MyCtx, data * MyData, share bool) (* MyData, bool) {
-	new := uintptr(unsafe.Pointer(ctx))
-	// old_d := ctx.d
-
-	// Attempt to CAS our context into the seat
-	var raw uintptr
-	for true {
-		raw = this.ptr
-		if raw == uintptr(1) { // Seat is closed, return
-			return nil, true
-		}
-		if atomic.CompareAndSwapUintptr(&this.ptr, raw, new) {
-			break // We got the seat
-		}
-	}
-
-	// If we aren't the fist in, wake someone
-	if raw != uintptr(0) {
-		var val *MyCtx
-		val = (*MyCtx)(unsafe.Pointer(raw))
-
-		// If we are sharing, give them our data
-		if share {
-			// fmt.Printf("[%d] - %d update %d: %p -> %p\n", this.id, ctx.id, val.id, val.d, data)
-			atomic.StorePointer(&val.d, unsafe.Pointer(data))
-		}
-
-		// Wake them up
-		// fmt.Printf("[%d] - %d release %d\n", this.id, ctx.id, val.id)
-		val.s.Release(1)
-	}
-
-	// fmt.Printf("[%d] - %d enter\n", this.id, ctx.id)
-
-	// Block once on the seat
-	ctx.s.Acquire(ctx.c, 1)
-
-	// Someone woke us up, get the new data
-	ret := (* MyData)(atomic.LoadPointer(&ctx.d))
-	// fmt.Printf("[%d] - %d leave: %p -> %p\n", this.id, ctx.id, ret, old_d)
-
-	return ret, false
-}
-
-// Shutdown the spot
-// Wake current thread and mark seat as closed
-func (this * Spot) release() {
-	val := (*MyCtx)(unsafe.Pointer(atomic.SwapUintptr(&this.ptr, uintptr(1))))
-	if val == nil {
-		return
-	}
-
-	// Someone was there, release them
-	val.s.Release(1)
-}
-
-// ==================================================
-// Struct for result, Go doesn't support passing tuple in channels
-type Result struct {
-	count uint64
-	gmigs uint64
-	dmigs uint64
-}
-
-func NewResult() (Result) {
-	return Result{0, 0, 0}
-}
-
-// ==================================================
-// Random number generator, Go's native one is to slow and global
-func __xorshift64( state * uint64 ) (uint64) {
-	x := *state
-	x ^= x << 13
-	x ^= x >> 7
-	x ^= x << 17
-	*state = x
-	return x
-}
-
-// ==================================================
-// Do some work by accessing 'cnt' cells in the array
-func work(data * MyData, cnt uint64, state * uint64) {
-	for i := uint64(0); i < cnt; i++ {
-		data.access(__xorshift64(state))
-	}
-}
-
-// Main body of the threads
-func local(result chan Result, start chan struct{}, size uint64, cnt uint64, channels [] Spot, share bool, id int) {
-	// Initialize some data
-    	state := rand.Uint64()    // RNG state
-	data := NewData(id, size) // Starting piece of data
-	ctx := NewCtx(data, id)   // Goroutine local context
-
-	// Prepare results
-	r := NewResult()
-
-	// Wait for start
-	<- start
-
-	// Main loop
-	for true {
-		// Touch our current data, write to invalidate remote cache lines
-		work(data, cnt, &state)
-
-		// Wait on a random spot
-		i := __xorshift64(&state) % uint64(len(channels))
-		var closed bool
-		data, closed = channels[i].put(&ctx, data, share)
-
-		// Check if the experiment is over
-		if closed { break }                                       // yes, spot was closed
-		if  clock_mode && atomic.LoadInt32(&stop) == 1 { break }  // yes, time's up
-		if !clock_mode && r.count >= stop_count { break }         // yes, iterations reached
-
-		// Check everything is consistent
-		if uint64(len(data.data)) != size { panic("Data has weird size") }
-
-		// write down progress and check migrations
-		ttid := syscall.Gettid()
-		r.count += 1
-		r.gmigs += ctx .moved(ttid)
-		r.dmigs += data.moved(ttid)
-	}
-
-	// Mark goroutine as done
-	atomic.AddInt64(&threads_left, -1);
-
-	// return result
-	result <- r
-}
-
-// ==================================================
-// Program main
-func main() {
-	// Benchmark specific command line arguments
-	nspotsOpt    := flag.Int   ("n", 0    , "Number of spots where threads sleep (nthreads - nspots are active at the same time)")
-	work_sizeOpt := flag.Uint64("w", 2    , "Size of the array for each threads, in words (64bit)")
-	countOpt     := flag.Uint64("c", 2    , "Number of words to touch when working (random pick, cells can be picked more than once)")
+	work_sizeOpt := flag.Uint64("w", 2    , "Number of words (uint64) per threads")
+	countOpt     := flag.Uint64("c", 2    , "Number of words (uint64) to touch")
 	shareOpt     := flag.Bool  ("s", false, "Pass the work data to the next thread when blocking")
 
-	// General benchmark initialization and deinitialization
-	defer bench_init()()
+	bench_init()
 
-	// Eval command line arguments
-	nspots:= *nspotsOpt
 	size  := *work_sizeOpt
 	cnt   := *countOpt
 	share := *shareOpt
 
-	if nspots == 0 { nspots = nthreads - nprocs; }
-
-	// Check params
 	if ! (nthreads > nprocs) {
 		fmt.Fprintf(os.Stderr, "Must have more threads than procs\n")
@@ -243,26 +80,24 @@
 	}
 
-	// Make global data
-	barrierStart := make(chan struct{})         // Barrier used at the start
-	threads_left = int64(nthreads - nspots)                // Counter for active threads (not 'nthreads' because at all times 'nthreads - nprocs' are blocked)
-	result  := make(chan Result)                // Channel for results
-	channels := make([]Spot, nspots) // Number of spots
+	barrierStart := make(chan struct{})
+	barrierStop  := make(chan struct{})
+	threads_left = int64(nthreads)
+	result  := make(chan uint64)
+	channels := make([]chan [] uint64, nthreads - nprocs)
 	for i := range channels {
-		channels[i] = Spot{[16]uint64{0},uintptr(0), i,[16]uint64{0}}     // init spots
+		channels[i] = make(chan [] uint64, 1)
 	}
 
-	// start the goroutines
 	for i := 0; i < nthreads; i++ {
-		go local(result, barrierStart, size, cnt, channels, share, i)
+		go local(result, barrierStart, barrierStop, size, cnt, channels, uint64(nthreads - nprocs), share)
 	}
 	fmt.Printf("Starting\n");
 
-	atomic.StoreInt32(&stop, 0)
 	start := time.Now()
-	close(barrierStart) // release barrier
+	close(barrierStart)
 
-	wait(start, true);  // general benchmark wait
+	wait(start, true);
 
-	atomic.StoreInt32(&stop, 1)
+	close(barrierStop)
 	end := time.Now()
 	delta := end.Sub(start)
@@ -270,32 +105,20 @@
 	fmt.Printf("\nDone\n")
 
-	// release all the blocked threads
-	for i := range channels {
-		channels[i].release()
+	global_counter := uint64(0)
+	for i := 0; i < nthreads; i++ {
+		global_counter += <- result
 	}
 
-	// Join and accumulate results
-	results := NewResult()
-	for i := 0; i < nthreads; i++ {
-		r := <- result
-		results.count += r.count
-		results.gmigs += r.gmigs
-		results.dmigs += r.dmigs
-	}
-
-	// Print with nice 's, i.e. 1'000'000 instead of 1000000
 	p := message.NewPrinter(language.English)
-	p.Printf("Duration (s)           : %f\n", delta.Seconds());
+	p.Printf("Duration (ms)          : %f\n", delta.Seconds());
 	p.Printf("Number of processors   : %d\n", nprocs);
 	p.Printf("Number of threads      : %d\n", nthreads);
 	p.Printf("Work size (64bit words): %d\n", size);
-	p.Printf("Total Operations(ops)  : %15d\n", results.count)
-	p.Printf("Total G Migrations     : %15d\n", results.gmigs)
-	p.Printf("Total D Migrations     : %15d\n", results.dmigs)
-	p.Printf("Ops per second         : %18.2f\n", float64(results.count) / delta.Seconds())
-	p.Printf("ns per ops             : %18.2f\n", float64(delta.Nanoseconds()) / float64(results.count))
-	p.Printf("Ops per threads        : %15d\n", results.count / uint64(nthreads))
-	p.Printf("Ops per procs          : %15d\n", results.count / uint64(nprocs))
-	p.Printf("Ops/sec/procs          : %18.2f\n", (float64(results.count) / float64(nprocs)) / delta.Seconds())
-	p.Printf("ns per ops/procs       : %18.2f\n", float64(delta.Nanoseconds()) / (float64(results.count) / float64(nprocs)))
+	p.Printf("Total Operations(ops)  : %15d\n", global_counter)
+	p.Printf("Ops per second         : %18.2f\n", float64(global_counter) / delta.Seconds())
+	p.Printf("ns per ops             : %18.2f\n", float64(delta.Nanoseconds()) / float64(global_counter))
+	p.Printf("Ops per threads        : %15d\n", global_counter / uint64(nthreads))
+	p.Printf("Ops per procs          : %15d\n", global_counter / uint64(nprocs))
+	p.Printf("Ops/sec/procs          : %18.2f\n", (float64(global_counter) / float64(nprocs)) / delta.Seconds())
+	p.Printf("ns per ops/procs       : %18.2f\n", float64(delta.Nanoseconds()) / (float64(global_counter) / float64(nprocs)))
 }
Index: benchmark/readyQ/rq_bench.hfa
===================================================================
--- benchmark/readyQ/rq_bench.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/readyQ/rq_bench.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -39,5 +39,5 @@
 		} else if(stop_count > 0) { \
 			clock_mode = false; \
-			printf("Running for %llu iterations\n", stop_count); \
+			printf("Running for %lu iterations\n", stop_count); \
 		} else { \
 			duration = 5; clock_mode = true;\
Index: benchmark/readyQ/rq_bench.hpp
===================================================================
--- benchmark/readyQ/rq_bench.hpp	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ benchmark/readyQ/rq_bench.hpp	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -97,18 +97,4 @@
 }
 
-bool parse_truefalse(const char * arg, bool & value) {
-	if(strcmp(arg, "true") == 0) {
-		value = true;
-		return true;
-	}
-
-	if(strcmp(arg, "false") == 0) {
-		value = false;
-		return true;
-	}
-
-	return false;
-}
-
 bool parse_settrue (const char *, bool & value ) {
 	value = true;
@@ -240,5 +226,5 @@
 	{
 		int idx = 0;
-		for(size_t i = 0; i < opt_count; i++) {
+		for(int i = 0; i < opt_count; i++) {
 			if(options[i].long_name) {
 				optarr[idx].name = options[i].long_name;
@@ -270,5 +256,5 @@
 	{
 		int idx = 0;
-		for(size_t i = 0; i < opt_count; i++) {
+		for(int i = 0; i < opt_count; i++) {
 			optstring[idx] = options[i].short_name;
 			idx++;
@@ -293,12 +279,10 @@
 			case 'h':
 				out = stdout;
-				[[fallthrough]];
 			case '?':
 				usage(argv[0], options, opt_count, usage_msg, out);
 			default:
-				for(size_t i = 0; i < opt_count; i++) {
+				for(int i = 0; i < opt_count; i++) {
 					if(opt == options[i].short_name) {
 						const char * arg = optarg ? optarg : "";
-						if( arg[0] == '=' ) { arg++; }
 						bool success = options[i].parse_fun( arg, options[i].variable );
 						if(success) goto NEXT_ARG;
@@ -335,5 +319,5 @@
 	int width = 0;
 	{
-		for(size_t i = 0; i < opt_count; i++) {
+		for(int i = 0; i < opt_count; i++) {
 			if(options[i].long_name) {
 				int w = strlen(options[i].long_name);
@@ -354,5 +338,5 @@
 	fprintf(out, "Usage:\n  %s %s\n", cmd, help);
 
-	for(size_t i = 0; i < opt_count; i++) {
+	for(int i = 0; i < opt_count; i++) {
 		printopt(out, width, max_width, options[i].short_name, options[i].long_name, options[i].help);
 	}
Index: configure.ac
===================================================================
--- configure.ac	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ configure.ac	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -295,6 +295,6 @@
 # Some of our makefile don't need to be distributed
 AM_CONDITIONAL([CFORALL_DISTRIBUTE], [test -e $TOP_SRCDIR/autogen.sh])
-AM_COND_IF([CFORALL_DISTRIBUTE], [
-	AC_CONFIG_FILES([
+AM_COND_IF([CFORALL_DISTRIBUTE],
+	[AC_CONFIG_FILES([
 		longrun_tests/Makefile
 		benchmark/Makefile
@@ -302,8 +302,5 @@
 		tools/Makefile
 		tools/prettyprinter/Makefile
-	])
-
-	AC_OUTPUT(benchmark/Cargo.toml)
-])
+		])])
 
 AC_CONFIG_LINKS([tests/test.py:tests/test.py])
Index: doc/theses/thierry_delisle_PhD/thesis/Makefile
===================================================================
--- doc/theses/thierry_delisle_PhD/thesis/Makefile	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ doc/theses/thierry_delisle_PhD/thesis/Makefile	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -28,8 +28,4 @@
 	base \
 	empty \
-	emptybit \
-	emptytls \
-	emptytree \
-	fairness \
 	system \
 }
@@ -77,7 +73,4 @@
 	${LaTeX} $<
 
-build/fairness.svg : fig/fairness.py | ${Build}
-	python3 $< $@
-
 ## Define the default recipes.
 
@@ -95,10 +88,4 @@
 	fig2dev -L pstex_t -p ${Build}/$@ $< > ${Build}/$@_t
 
-%.pstex : build/%.svg | ${Build}
-	inkscape -z -D --file=$< --export-eps=${Build}/$@ --export-latex
-	mv ${Build}/$@_tex ${Build}/$@_t
-	echo "sed -i 's/$@/${Build}/$@/g' ${Build}/$@_t"
-	sed -i 's/$@/${Build}\/$@/g' ${Build}/$@_t
-
 ## pstex with inverted colors
 %.dark.pstex : fig/%.fig Makefile | ${Build}
Index: libcfa/src/Makefile.am
===================================================================
--- libcfa/src/Makefile.am	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/Makefile.am	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -58,9 +58,5 @@
 	concurrency/iofwd.hfa \
 	containers/list.hfa \
-	containers/stackLockFree.hfa \
-	vec/vec.hfa \
-	vec/vec2.hfa \
-	vec/vec3.hfa \
-	vec/vec4.hfa
+	containers/stackLockFree.hfa
 
 inst_headers_src = \
@@ -98,5 +94,4 @@
 	concurrency/clib/cfathread.h \
 	concurrency/invoke.h \
-	concurrency/future.hfa \
 	concurrency/kernel/fwd.hfa
 
Index: libcfa/src/bits/collection.hfa
===================================================================
--- libcfa/src/bits/collection.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/collection.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -1,12 +1,10 @@
 #pragma once
-#include <stdio.h> // REMOVE THIS AFTER DEBUGGING
-
 
 struct Colable {
-	struct Colable * next;										// next node in the list
+	Colable * next;										// next node in the list
 	// invariant: (next != 0) <=> listed()
 };
-#ifdef __cforall
-static inline {
+
+inline {
 	// PUBLIC
 
@@ -30,17 +28,16 @@
 	}
 
-	// // wrappers to make Collection have T
-	// forall( dtype T ) {
-	// 	T *& Next( T * n ) {
-	// 		return (T *)Next( (Colable *)n );
-	// 	}
-	// } // distribution
+	// wrappers to make Collection have T
+	forall( dtype T ) {
+		T *& Next( T * n ) {
+			return (T *)Next( (Colable *)n );
+		}
+
+		bool listed( T * n ) {
+			return Next( (Colable *)n ) != 0p;
+		}
+	} // distribution
 } // distribution
 
-forall( dtype T | { T *& Next ( T * ); } ) {
-	bool listed( T * n ) {
-		return Next( n ) != 0p;
-	}
-}
 
 struct Collection {
@@ -48,5 +45,5 @@
 };
 
-static inline {
+inline {
 	// class invariant: root == 0 & empty() | *root in *this
 	void ?{}( Collection &, const Collection & ) = void; // no copy
@@ -68,8 +65,8 @@
 
 struct ColIter {
-	void * curr;										// element returned by |
+	void * curr;										// element to be returned by >>
 };
 
-static inline {
+inline {
 	void ?{}( ColIter & colIter ) with( colIter ) {
 		curr = 0p;
@@ -82,3 +79,2 @@
 	} // distribution
 } // distribution
-#endif
Index: libcfa/src/bits/containers.hfa
===================================================================
--- libcfa/src/bits/containers.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/containers.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -36,5 +36,5 @@
 	#define __small_array_t(T) __small_array(T)
 #else
-	#define __small_array_t(T) __small_array
+	#define __small_array_t(T) struct __small_array
 #endif
 
Index: libcfa/src/bits/defs.hfa
===================================================================
--- libcfa/src/bits/defs.hfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ libcfa/src/bits/defs.hfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -29,5 +29,5 @@
 #define __cfa_anonymous_object(x) inline struct x
 #else
-#define __cfa_anonymous_object(x) struct x __cfa_anonymous_object
+#define __cfa_anonymous_object(x) x __cfa_anonymous_object
 #endif
 
